package no.ntnu.idatt1002.demo.data.Budget;

import no.ntnu.idatt1002.demo.data.Economics.ExpenseCategory;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.DisplayName;
import org.junit.jupiter.api.Nested;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.*;

import java.io.IOException;
import java.time.LocalDate;
import java.time.Month;

import static org.junit.jupiter.api.Assertions.*;


import java.io.IOException;

class FileHandlingBudgetTest {
    BudgetItem foodItem;
    BudgetItem bookItem;
    BudgetItem clothesItem;
    FileHandlingBudget fileHandlingBudget = new FileHandlingBudget();


    @Nested
    @DisplayName("FileHandling budget with one BudgetItem does not throw exception")
    class fileHandlingBudgetWithOneBudgetItemDoesNotThrowException{
        GeneralBudget generalBudget = new GeneralBudget(12, 1200);
        String fileTitle = "oneBudgetItemTest";

        @BeforeEach
        void createGeneralBudget(){
            foodItem = new BudgetItem(500, "description", ExpenseCategory.FOOD);
            generalBudget.addToBudgetBudgetItem(foodItem);
        }
        @Test
        @DisplayName("Writing to file does not throw exception")
        void writeGeneralBudgetToFileDoesNotThrowException() throws IOException {
            assertDoesNotThrow(() -> fileHandlingBudget.writeGeneralBudgetToFile(fileTitle,generalBudget));
        }

        @Test
        @DisplayName("Reading from file gives correct budget back")
        void readingGeneralBudgetFromFileDoesNotThrowException()throws IOException{
            assertEquals(generalBudget,fileHandlingBudget.readGeneralBudgetFromFile(fileTitle));
        }
    }

    @Nested
    @DisplayName("FileHandling budget with multiple BudgetItems does not throw exception")
    class FileHandlingBudgetWithMultipleBudgetItemsDoesNotThrowException{
        GeneralBudget generalBudget = new GeneralBudget(12, 1200);
        String fileTitle = "multipleBudgetItem";
        @BeforeEach
        void createGeneralBudget(){
            foodItem = new BudgetItem(500, "description", ExpenseCategory.FOOD);
            bookItem = new BudgetItem(200, "anotherDescription", ExpenseCategory.BOOKS);
            clothesItem = new BudgetItem(150, "anotheranotherdescription", ExpenseCategory.CLOTHES);
            generalBudget.addToBudgetBudgetItem(foodItem);
            generalBudget.addToBudgetBudgetItem(bookItem);
            generalBudget.addToBudgetBudgetItem(clothesItem);
        }
        @Test
        @DisplayName("Writing to file does not throw exception")
        void writeGeneralBudgetToFileDoesNotThrowException() throws IOException {
            assertDoesNotThrow(()->fileHandlingBudget.writeGeneralBudgetToFile(fileTitle,generalBudget));
        }

        @Test
        @DisplayName("Reading from file gives correct budget back")
        void readingGeneralBudgetFromFileDoesNotThrowException()throws IOException{
            assertEquals(generalBudget,fileHandlingBudget.readGeneralBudgetFromFile(fileTitle));
        }
    }

}
